<?php

App::uses('AppComponent', 'Controller/Component');
App::uses('TemplateUtil', 'Lib');

class TemplateComponent extends AppComponent {

	/**
	 * run the form injection
	 * For custom fields this add type / validation arrays to the template for fields
	 *
	 * @param   array       Data from $this->request->data
	 * @param   object      Model Object for the primary model we are dealing with
	 * @param   int|null    The ID if on edit or null of add
	 */
	public function injectAdminForm($data, $Model, $id) {
		// get all the templates for the Form
		$Template = EvClassRegistry::init('EvTemplates.Template');

		$this->_controller->viewVars['fields'][$Model->alias . '.template_id']['class'] = 'ev-templates-template-selector';

		$restrictTo = array();

		// Check the model to see if we're wanting to only show templates that are assigned to specific models.
		if (isset($Model->actsAs['Template']['restrictTo']) && ! empty($Model->actsAs['Template']['restrictTo'])) {
			$restrictTo = $Model->actsAs['Template']['restrictTo'];
		}

		$templates = $Template->selectList($restrictTo);
		$this->_controller->set(compact('templates'));

		// if the templates array consists of one result, then auto assign the
		// request data to that result
		if (! empty($templates) && count($templates) == 1) {
			$this->_controller->request->data[$Model->alias]['template_id'] = key($templates);
		}
	}
}
